#ifndef OF_HEPMC_H
#define OF_HEPMC_H

#include "OutputFormat.h"
#include "HepMC3/GenParticle.h"
#include "HepMC3/GenVertex.h"

namespace HepMC3 {
class Writer;
class GenEvent;
}

namespace SANC {

class Info;
class Process;

class OF_HEPMC : public OutputFormat {
public:
  OF_HEPMC(Info &_info, Process &_proc);
  ~OF_HEPMC() {}
  void start(std::string dirName, std::string fileName);
  void writeEvent(/*Event*/);
  void finish();

private:
  HepMC3::Writer *output;
  // HepMC3::GenEvent *hepmc;
  std::string dirName, fileName;
  std::vector<HepMC3::GenParticlePtr> hepevt_particles;
  std::vector<HepMC3::GenVertexPtr> vertex_cache;
  std::vector<HepMC3::GenParticlePtr> beam_particles;
  HepMC3::GenCrossSectionPtr xsec;
  int nEvents;
};

} // namespace SANC

#endif // OF_HEPMC_H