// TFoam wrapper class
// Based on root/foam
// Original authors: S. Jadach <mailto:Stanislaw.jadach@ifj.edu.pl>, P.Sawicki <mailto:Pawel.Sawicki@ifj.edu.pl>

#ifndef ROOT_TFoamW
#define ROOT_TFoamW

#include "TFoam.h"

class TFoamCell;
class TFoamW : public TFoam {
protected:
  Double_t fInitResult; ///< True Integral R from initialization
  Double_t fInitError;  ///< and its error estimation
public:
  TFoamW();               // Default constructor (used only by ROOT streamer)
  TFoamW(const Char_t *); // Principal user-defined constructor
  ~TFoamW() override;     // Default destructor
  TFoamW(const TFoamW &); // Copy Constructor  NOT USED
  // Initialization
  virtual void Initialize(); // Initialization of the FOAM (grid, cells, etc), mandatory!
  // Getters and Setters
  virtual void GetIntegInit(Double_t &,
                            Double_t &); // Provides Integrand and abs. error from initialization
private:
  TFoamCell *getCell(std::size_t i) const;
};

#endif
