#include "OF_HEPEVT.h"
#include "Info.h"
#include "Process.h"
#include <iomanip>

#define SP12 std::setprecision(12) << std::setw(21)
#define SP11 std::scientific << std::setprecision(11) << std::setw(19)
#define SW2 std::setw(2)
#define SW3 std::setw(3)
#define SW4 std::setw(4)
#define SW6 std::setw(6)
#define SW9 std::setw(9)
#define SW18 std::setw(18)

using namespace SANC;

OF_HEPEVT::OF_HEPEVT(Info &_info, Process &_proc) : OutputFormat(_info, _proc) {}

void OF_HEPEVT::start(std::string _dirName, std::string _fileName) {
  dirName = _dirName;
  fileName = _fileName;
  output.open(dirName + "/" + fileName + ".hepevt");
}

void OF_HEPEVT::writeEvent() {
  int nop = proc.nup - 2; // Number of outgoing particles

  output << SW2 << proc.nup << SW2 << nop << SW2 << 0 << SP11 << proc.event.weight() << std::endl;
  for (int i = 3; i <= proc.nup; i++) {
    output << SW3 << proc.idup[i] << SW2 << 0 << '\n';
    output << SP11 << proc.event.P_lab(i).px() << SP11 << proc.event.P_lab(i).py() << SP11
           << proc.event.P_lab(i).pz() << SP11 << proc.event.P_lab(i).pz() << SP11
           << proc.event.P_lab(i).e() << '\n';
  }
}

void OF_HEPEVT::finish() { output.close(); }